%{



#include "config.h"
#include <stdlib.h>
#ifndef VXWORKS
#include <sys/file.h>
#endif


#include "constant.h"
#include "macro.h"
#include "opaque.h"
#include "oprs-type.h"

#ifdef GRAPHIX
#include <X11/Intrinsic.h>
#include <Xm/Xm.h>
#endif

#include "op-structure.h"
#include "parser-funct.h"

#include "soak_f.h"
#include "oprs-type_f.h"
#include "parser-funct_f.h"

#include "oprs-parser.h"






#include "shashPack_f.h"







#define YY_INPUT(buf,result,max_size) \
	if ( YY_CURRENT_BUFFER->yy_is_interactive ) \
		{ \
		int c = '*', n; \
		for ( n = 0; n < max_size && \
			     (c = getc( yyin )) != EOF && c != '\n'; ++n ) \
			buf[n] = (char) c; \
		if ( c == '\n' ) \
			buf[n++] = (char) c; \
		if ( c == EOF && ferror( yyin ) ) \
			YY_FATAL_ERROR( "input in flex scanner failed" ); \
		result = n; \
		} \
	else if ( ((result = fread( buf, 1, max_size, yyin )) == 0) \
		  && (parse_source == PS_FILE) && ferror( yyin ) ) \
		YY_FATAL_ERROR( "input in flex scanner failed" );


%}





ws		[ \t]+
real 		[-\+]?[0-9]+\.[0-9]*
exp		[eE][-\+]?[0-9]+
integer 	[-\+]?[0-9]+[l]?
long_long 	[-\+]?[0-9]+ll
pointer 	0x[0123456789abcdefABCDEF]+
comment		;.*$
qstring 	\"([^"]|\\["])*\" 
untypedid	([^ \t\n~0123456789"&\(\)\$@;\|\.[\]][^ \t\n"\(\)\]]*)
typedid 	([^ \t\n~0123456789:"&\(\)\$@;\|\.[\]][^ \t\n:"\(\)\]]*)

idbar   	(\|[^|]+\|)
nl		\n
or		V
and		&
op		\(
cp		\)
opar		\[
cpar		\]
oplisp		\(\.
cplisp		\.\)
lvar		\${id}
pvar		@{id}
gpvar		@@{id}


id {typedid}

     
%s COMMAND OPF_VERSION NODE_TYPE FIELD_TYPE EDGE_TYPE ACTION_TYPE COLLECT_COMMENT EOFS

%%
{ws}		;
<COMMAND>h	|
<COMMAND>help	|
<COMMAND>\?	{return HELP_TK;}

<COMMAND>add		{return ADD_TK;}
<COMMAND>conclude	{return CONCLUDE_TK;}
<COMMAND>consult	{return CONSULT_TK;}
<COMMAND>declare	{return DECLARE_TK;}
<COMMAND>undeclare	{return UNDECLARE_TK;}
<COMMAND>delete		{return DELETE_TK;}
<COMMAND>echo		{return ECHO_TK;}
<COMMAND>empty		{return EMPTY_TK;}
<COMMAND>include	{return INCLUDE_TK;}
<COMMAND>require	{return REQUIRE_TK;}
<COMMAND>list		{return LIST_TK;}
<COMMAND>load		{return LOAD_TK;}
<COMMAND>reload		{return RELOAD_TK;}
<COMMAND>receive 	{return RECEIVE_TK;}
<COMMAND>reset	 	{return RESET_TK;}
<COMMAND>send	 	{return SEND_TK;}
<COMMAND>set		{return SET_TK;}
<COMMAND>show		{return SHOW_TK;}
<COMMAND>stat		{return STAT_TK;}
<COMMAND>save		{return SAVE_TK;}
<COMMAND>dump		{return DUMP_TK;}
<COMMAND>trace		{return TRACE_TK;}
<COMMAND>unify		{return UNIFY_TK;}
<COMMAND>make		{return MAKE_TK;}
<COMMAND>user		{return USER_TK;}
<COMMAND>completion	{return COMPLETION_TK;}

<COMMAND>variable	{return VARIABLE_TK;}
<COMMAND>db		{return DB_TK;}
<COMMAND>type		{return TYPE_TK;}
<COMMAND>fact		{return FACT_TK;}
<COMMAND>goal		{return GOAL_TK;}
<COMMAND>intention	{return INTENTION_TK;}
<COMMAND>condition	{return CONDITION_TK;}
<COMMAND>op		|
<COMMAND>ka		{return OP_TK;}
<COMMAND>opf		|
<COMMAND>kaf		{return OPF_TK;}
<COMMAND>kernel		{return KERNEL_TK;}
<COMMAND>soak		{return SOAK_TK;}

<COMMAND>meta		{return META_TK;}
<COMMAND>eval 		{return EVAL_TK;}
<COMMAND>post		{return POST_TK;}
<COMMAND>parallel	{return PARALLEL_TK;}
<COMMAND>profiling	{return PROFILING_TK;}
<COMMAND>silent 	{return SILENT_TK;}
<COMMAND>frame		{return FRAME_TK;}
<COMMAND>thread		{return THREADING_TK;}
<COMMAND>intend		{return INTEND_TK;}
<COMMAND>suc_fail	{return SUC_FAIL_TK;}
<COMMAND>failure	{return FAILURE_TK;}
<COMMAND>all		{return ALL_TK;}
<COMMAND>oprs_data_path	{return OPRS_DATA_PATH_TK;}

<COMMAND>on		{return ON_TK;}
<COMMAND>off		{return OFF_TK;}

<COMMAND>version	{return VERSION_TK;}
<COMMAND>copyright	{return COPYRIGHT_TK;}
<COMMAND>memory		{return MEMORY_TK;}

<COMMAND>op_predicate	{return OP_PREDICATE_TK;}
<COMMAND>predicate	{return PREDICATE_TK;}
<COMMAND>function	{return FUNCTION_TK;}
<COMMAND>action		{return AC_TK;}
<COMMAND>external	{return EXTERNAL_TK;}
<COMMAND>symbol		{return SYM_TK;}
<COMMAND>tsymbol	{return TSYM_TK;}
<COMMAND>evaluable	{return EVALUABLE_TK;}
<COMMAND>ff		{return FF_TK;}
<COMMAND>be		{return BE_TK;}
<COMMAND>cwp		{return CWP_TK;}
<COMMAND>relevant	{return RELEVANT_TK;}
<COMMAND>applicable 	{return APPLICABLE_TK;}

<COMMAND>take_stdin	{return TAKE_STDIN_TK;}
<COMMAND>disconnect	{return DISCONNECT_TK;}
<COMMAND>step		{return STEP_TK;}
<COMMAND>next		{return NEXT_TK;}
<COMMAND>halt		{return HALT_TK;}
<COMMAND>run		{return RUN_TK;}
<COMMAND>status		{return STATUS_TK;}

<COMMAND>quit		|
<COMMAND>q		|
<COMMAND>exit		{return QUIT_TK;}

<COMMAND>text		{return TEXT_TK;}
<COMMAND>graphic	{return GRAPHIC_TK;}

<COMMAND>call_external	{return CALL_EXTERNAL_TK;}






<OPF_VERSION>1				{return OPF_VERSION1;}
<OPF_VERSION>2				{return OPF_VERSION2;}

<FIELD_TYPE>INVOCATION			{return FT_INVOCATION_TK;}
<FIELD_TYPE>CONTEXT			{return FT_CONTEXT_TK;}
<FIELD_TYPE>CALL			{return FT_CALL_TK;}
<FIELD_TYPE>SETTING			{return FT_SETTING_TK;}
<FIELD_TYPE>PROPERTIES			{return FT_PROPERTIES_TK;}
<FIELD_TYPE>DOCUMENTATION		{return FT_DOCUMENTATION_TK;}
<FIELD_TYPE>EFFECTS			{return FT_EFFECTS_TK;}
<FIELD_TYPE>ACTION			{return FT_ACTION_TK;}

<NODE_TYPE>PROCESS			{return NT_PROCESS_TK;}
<NODE_TYPE>START			{return NT_START_TK;}
<NODE_TYPE>END				{return NT_END_TK;}
<NODE_TYPE>ELSE				{return NT_ELSE_TK;}
<NODE_TYPE>THEN				{return NT_THEN_TK;}
<NODE_TYPE>IF				{return NT_IF_TK;}

<EDGE_TYPE>GOAL			{return ET_GOAL_TK;}
<EDGE_TYPE>ELSE			{return ET_ELSE_TK;}
<EDGE_TYPE>THEN			{return ET_THEN_TK;}
<EDGE_TYPE>IF			{return ET_IF_TK;}

<ACTION_TYPE>\*=\*			{return SPEC_ACT_TK;}







:[Ii][Nn][Vv][Oo][Cc][Aa][Tt][Ii][Oo][Nn]		{return TFT_INVOCATION_TK;}
:[Bb][Oo][Dd][Yy]					{return TFT_BODY_TK;}
:[Cc][Oo][Nn][Tt][Ee][Xx][Tt]				{return TFT_CONTEXT_TK;}
:[Cc][Aa][Ll][Ll]				{return TFT_CALL_TK;}
:[Ss][Ee][Tt][Tt][Ii][Nn][Gg]				{return TFT_SETTING_TK;}
:[Pp][Rr][Oo][Pp][Ee][Rr][Tt][Ii][Ee][Ss]		{return TFT_PROPERTIES_TK;}
:[Dd][Oo][Cc][Uu][Mm][Ee][Nn][Tt][Aa][Tt][Ii][Oo][Nn]	{return TFT_DOCUMENTATION_TK;}
:[Ee][Ff][Ff][Ee][Cc][Tt][Ss]				{return TFT_EFFECTS_TK;}
:[Aa][Cc][Tt][Ii][Oo][Nn]				{return TFT_ACTION_TK;}

[Dd][Ee][Ff][Kk][Aa]					{return DEFOP_TK;}
[Dd][Ee][Ff][Oo][Pp]					{return DEFOP_TK;}
\/\/							{return PAR_TK;}
[Ww][Hh][Ii][Ll][Ee]					{return WHILE_TK;}
[Dd][Oo]						{return DO_TK;}
[Ii][Ff]						{return IF_TK;}
[Ee][Ll][Ss][Ee]					{return ELSE_TK;}
[Bb][Rr][Ee][Aa][Kk]					{return BREAK_TK;}
[Gg][Oo][Tt][Oo]					{return GOTO_TK;}
[Ll][Aa][Bb][Ee][Ll]					{return LABEL_TK;}
[Ee][Ll][Ss][Ee][Ii][Ff]				{return ELSEIF_TK;}

<COLLECT_COMMENT>{comment}		{ NEWSTR(oprs_yytext,oprs_yylval.string);
					  return COMMENT_TK;}








: 		{return TYPE_SEP_TK;}






^\.\n		{ parser_line_number[parser_index]++;
                  return RESET_DOT_TK;} 


{real}		|
{real}{exp}    	{ sscanf(oprs_yytext,"%lf",&oprs_yylval.real);
		  return REAL_TK;}
{pointer}       { sscanf(oprs_yytext+2,"%x", (unsigned int *)&oprs_yylval.pointer); 
		  return POINTER_TK;}
{long_long}       { sscanf(oprs_yytext,"%lld", &oprs_yylval.long_long);
		  return LONG_LONG_TK;}
{integer}       { sscanf(oprs_yytext,"%d", &oprs_yylval.integer);
		  return INTEGER_TK;}
{comment}	;
{qstring}	{ NEWQSTR(oprs_yytext,oprs_yylval.string);
		  return QSTRING_TK;}

\|\|		{ oprs_yylval.symbol = or_sym;
		  return SYMBOL_TK;}
&		{ oprs_yylval.symbol = and_sym;
		  return SYMBOL_TK;}
~		{ oprs_yylval.symbol = not_sym;
		  return SYMBOL_TK;}


{lvar}		{ DECLARE_VAR(oprs_yytext,oprs_yylval.symbol);
		  return LOGICAL_VAR_TK;}
{pvar} |
{gpvar}		{ DECLARE_VAR(oprs_yytext,oprs_yylval.symbol);
		  return PROGRAM_VAR_TK;}


\+>		{  oprs_yylval.symbol = cond_add_sym;
		  return SYMBOL_TK;}
->		{  oprs_yylval.symbol = cond_del_sym;
		  return SYMBOL_TK;}
=>		{  oprs_yylval.symbol = temp_conclude_sym;
		  return SYMBOL_TK;}
~> 		{  oprs_yylval.symbol = retract_sym;
		  return SYMBOL_TK;}
! 		{  oprs_yylval.symbol = achieve_sym;
		  return SYMBOL_TK;}
\?	 	{  oprs_yylval.symbol = test_sym;
		  return SYMBOL_TK;}
#		{  oprs_yylval.symbol = preserve_sym;
		  return SYMBOL_TK;}
\^	 	{  oprs_yylval.symbol = twait_sym;
		  return SYMBOL_TK;}
\%		{  oprs_yylval.symbol = maintain_sym;
		  return SYMBOL_TK;}
\<>		{  oprs_yylval.symbol = call_sym;
		  return SYMBOL_TK;}


{oplisp}        { return OP_LISP_TK;}
{cplisp}        { return CP_LISP_TK;}
{opar}          { return OP_ARRAY_TK;}
{cpar}          { return CP_ARRAY_TK;}


t	|
T		{ oprs_yylval.symbol = lisp_t_sym;
		  return SYMBOL_TK;}
[nN][iI][lL]	{ oprs_yylval.symbol = nil_sym;
		  return SYMBOL_TK;}

{id} |
{idbar}		{ DECLARE_ID(oprs_yytext,oprs_yylval.symbol);
		  return SYMBOL_TK;}

{op}        	{ return OPENP_TK;}
{cp}        	{ return CLOSEP_TK;}

{nl}	    	{parser_line_number[parser_index]++;}

.		{warning("unexpected character.");}


<EOFS><<EOF>>	 {yyterminate();} 
<<EOF>>		 {BEGIN EOFS; return EOF_TK;} 

%%
#include "mp-pub.h"
#include "yy-funct.c"

YY_BUFFER_STATE yy_stdin, yy_ps, yy_mp;
FILE *ps_file, *mp_file;

void take_the_stdin(void)

{
     if (parser_index == MAX_OPEN_INCLUDE) {
	  fprintf(stderr,LG_STR("Too many parser level opened.\n",
				"Trop de niveaux de parsing ouverts.\n"));
	  return;
     }

     i_have_the_stdin = TRUE;

     parser_state_save[parser_index] = YY_CURRENT_BUFFER;
     saved_parse_source[parser_index] = parse_source;

     parser_index++;
     parser_line_number[parser_index] = 1;
     parser_file_name[parser_index] = "stdin"; 
     FILE_save[parser_index] = NULL;

     parse_source = PS_FILE;

#if defined(HAVE_SETITIMER) && defined(WANT_TRIGGERED_IO)
     desarm_condition_timer();	
#endif
     oprs_yy_switch_to_buffer(yy_stdin);
     printf(LG_STR("Now parsing from stdin, the main loop is suspended.\n",
		   "Parsing du stdin, la boucle principale est suspendue.\n"));
}

void leave_the_stdin(void)

{
     if (!i_have_the_stdin) {
	  fprintf(stderr,LG_STR("You do not parse from stdin.\n",
				"Vous ne parsez pas de stdin.\n"));
	  return;
     }
     
     i_have_the_stdin = FALSE;
     parser_file_name[parser_index] = NULL;
     parser_line_number[parser_index] = 0;
     parser_index--;

     yy_switch_to_buffer(parser_state_save[parser_index]);
     parse_source = saved_parse_source[parser_index];

     printf(LG_STR("Quitting stdin parsing, the main loop is resumed.\n",
		   "Arret du parsing du stdin, la boucle principale est reprise.\n"));

#if defined(HAVE_SETITIMER) && defined(WANT_TRIGGERED_IO)
     arm_condition_timer();
#endif
}

void create_yy_mp(void)
{

     PROTECT_NULL_SYSCALL_FROM_EINTR(mp_file,fdopen(mp_socket,"r"));

     if (!mp_file) {
	  perror("create_yy_mp: fdopen");
     }

     yy_mp = oprs_yy_create_buffer(mp_file,YY_BUF_SIZE);
}

void create_yy_stdin_and_ps(void)
{
     yy_stdin = oprs_yy_create_buffer(stdin,YY_BUF_SIZE);

     PROTECT_NULL_SYSCALL_FROM_EINTR(ps_file,fdopen(ps_socket,"r"));

     if (!ps_file) {
	  perror("create_yy_stdin_and_ps: fdopen");
     }

     yy_ps = oprs_yy_create_buffer(ps_file,YY_BUF_SIZE);
}

void yy_switch_to_yy_ps(void)
{
     oprs_yy_switch_to_buffer(yy_ps);
}

void yy_switch_to_yy_mp(void)
{
     oprs_yy_switch_to_buffer(yy_mp);
}


void yy_begin_0(void)
{
     BEGIN 0;
}

void yy_begin_COMMAND()
{
     BEGIN COMMAND;
}

void yy_begin_OPF_VERSION(void)
{
     BEGIN OPF_VERSION;
}

void yy_begin_NODE_TYPE(void)
{
     BEGIN NODE_TYPE;
}

void yy_begin_FIELD_TYPE(void)
{
     BEGIN FIELD_TYPE;
}

void yy_begin_ACTION_TYPE(void)
{
     BEGIN ACTION_TYPE;
}

void yy_begin_EDGE_TYPE(void)
{
     BEGIN EDGE_TYPE;
}

void yy_begin_COLLECT_COMMENT(void)
{
     BEGIN COLLECT_COMMENT;
}

